unit mainformu;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Error, FireDAC.UI.Intf, FireDAC.Phys.Intf, FireDAC.Stan.Def,
  FireDAC.Stan.Pool, FireDAC.Stan.Async, FireDAC.Phys, FireDAC.Phys.IB,
  FireDAC.Phys.IBDef, FireDAC.Stan.Param, FireDAC.DatS, FireDAC.DApt.Intf,
  FireDAC.DApt, Data.DB, Vcl.Grids, Vcl.DBGrids, Vcl.StdCtrls,
  FireDAC.Comp.DataSet, FireDAC.Comp.Client, FireDAC.VCLUI.Wait, FireDAC.Comp.UI,
  Vcl.ExtCtrls, Vcl.DBCtrls;

type
  TForm1 = class(TForm)
    FDConnection1: TFDConnection;
    ApplyUpdatesBtn: TButton;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    OpenBtn: TButton;
    CustomerSource: TDataSource;
    FDSchemaAdapter1: TFDSchemaAdapter;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    FDGUIxWaitCursor1: TFDGUIxWaitCursor;
    CustomerMemTable: TFDMemTable;
    OrdersMemTable: TFDMemTable;
    FDTableAdapter1: TFDTableAdapter;
    FDTableAdapter2: TFDTableAdapter;
    FDCommand1: TFDCommand;
    FDCommand2: TFDCommand;
    CloseBtn: TButton;
    DBNavigator1: TDBNavigator;
    DBNavigator2: TDBNavigator;
    procedure OpenBtnClick(Sender: TObject);
    procedure ApplyUpdatesBtnClick(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure CloseBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ApplyUpdatesBtnClick(Sender: TObject);
begin
  FDConnection1.StartTransaction;
  FDSchemaAdapter1.ApplyUpdates(-1);
  FDConnection1.Commit;
end;

procedure TForm1.OpenBtnClick(Sender: TObject);
begin
  CustomerMemTable.Active := True;
  CustomerMemTable.CachedUpdates := True;
  OrdersMemTable.Open();
  OrdersMemTable.CachedUpdates := True;
  OpenBtn.Enabled := False;
  CloseBtn.Enabled := True;
end;

procedure TForm1.CloseBtnClick(Sender: TObject);
begin
  CustomerMemTable.Close;
  OrdersMemTable.Close;
  OpenBtn.Enabled := True;
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  ApplyUpdatesBtn.Enabled := CustomerMemTable.UpdatesPending or OrdersMemTable.UpdatesPending;
end;

end.
