unit mainformu;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DBXDataSnap, IPPeerClient,
  Data.DBXCommon, Data.DB, Datasnap.DBClient, Datasnap.DSConnect, Data.SqlExpr,
  Vcl.StdCtrls, Vcl.Grids, Vcl.DBGrids;

type
  TForm2 = class(TForm)
    DBGrid1: TDBGrid;
    ReadFromServerBtn: TButton;
    ApplyUpdatesBtn: TButton;
    ConnectBtn: TButton;
    DataSource1: TDataSource;
    SQLConnection1: TSQLConnection;
    DSProviderConnection1: TDSProviderConnection;
    ClientDataSet1: TClientDataSet;
    procedure ConnectBtnClick(Sender: TObject);
    procedure ReadFromServerBtnClick(Sender: TObject);
    procedure ApplyUpdatesBtnClick(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure TForm2.ApplyUpdatesBtnClick(Sender: TObject);
begin
  ClientDataSet1.ApplyUpdates(-1);
end;

procedure TForm2.ConnectBtnClick(Sender: TObject);
begin
  if ConnectBtn.Caption = 'Connect' then
  begin
    try
      SQLConnection1.Open;
    except
      on e: Exception do
      begin
        ShowMessage(e.Message);
        exit;
      end;
    end;
    ConnectBtn.Caption := 'Disconnect';
    ReadFromServerBtn.Enabled := True;

  end
  else
  begin
    SQLConnection1.Close;
    ClientDataSet1.Close;
    ReadFromServerBtn.Enabled := False;
    ApplyUpdatesBtn.Enabled := False;
    ConnectBtn.Caption := 'Connect';
  end;
end;

procedure TForm2.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  ApplyUpdatesBtn.Enabled := ClientDataSet1.ChangeCount > 0;
end;

procedure TForm2.ReadFromServerBtnClick(Sender: TObject);
begin
  ClientDataSet1.Open;
end;

end.
