//
// Created by the DataSnap proxy generator.
// 10/24/2014 4:42:23 PM
//

unit ServerMethodsClientu;

interface

uses System.JSON, Data.DBXCommon, Data.DBXClient, Data.DBXDataSnap, Data.DBXJSON, Datasnap.DSProxy, System.Classes, System.SysUtils, Data.DB, Data.SqlExpr, Data.DBXDBReaders, Data.DBXCDSReaders, Data.FireDACJSONReflect, Data.DBXJSONReflect;

type
  TServerMethods1Client = class(TDSAdminClient)
  private
    FDataModuleCreateCommand: TDBXCommand;
    FGetCustomerDataCommand: TDBXCommand;
    FGetCustomerDataJSONCommand: TDBXCommand;
    FApplyCustomerUpdatesCommand: TDBXCommand;
    FApplyCustomerUpdatesJSONCommand: TDBXCommand;
  public
    constructor Create(ADBXConnection: TDBXConnection); overload;
    constructor Create(ADBXConnection: TDBXConnection; AInstanceOwner: Boolean); overload;
    destructor Destroy; override;
    procedure DataModuleCreate(Sender: TObject);
    function GetCustomerData: TFDJSONDataSets;
    function GetCustomerDataJSON: TJSONObject;
    procedure ApplyCustomerUpdates(ADeltaList: TFDJSONDeltas);
    procedure ApplyCustomerUpdatesJSON(JSONObject: TJSONObject);
  end;

implementation

procedure TServerMethods1Client.DataModuleCreate(Sender: TObject);
begin
  if FDataModuleCreateCommand = nil then
  begin
    FDataModuleCreateCommand := FDBXConnection.CreateCommand;
    FDataModuleCreateCommand.CommandType := TDBXCommandTypes.DSServerMethod;
    FDataModuleCreateCommand.Text := 'TServerMethods1.DataModuleCreate';
    FDataModuleCreateCommand.Prepare;
  end;
  if not Assigned(Sender) then
    FDataModuleCreateCommand.Parameters[0].Value.SetNull
  else
  begin
    FMarshal := TDBXClientCommand(FDataModuleCreateCommand.Parameters[0].ConnectionHandler).GetJSONMarshaler;
    try
      FDataModuleCreateCommand.Parameters[0].Value.SetJSONValue(FMarshal.Marshal(Sender), True);
      if FInstanceOwner then
        Sender.Free
    finally
      FreeAndNil(FMarshal)
    end
    end;
  FDataModuleCreateCommand.ExecuteUpdate;
end;

function TServerMethods1Client.GetCustomerData: TFDJSONDataSets;
begin
  if FGetCustomerDataCommand = nil then
  begin
    FGetCustomerDataCommand := FDBXConnection.CreateCommand;
    FGetCustomerDataCommand.CommandType := TDBXCommandTypes.DSServerMethod;
    FGetCustomerDataCommand.Text := 'TServerMethods1.GetCustomerData';
    FGetCustomerDataCommand.Prepare;
  end;
  FGetCustomerDataCommand.ExecuteUpdate;
  if not FGetCustomerDataCommand.Parameters[0].Value.IsNull then
  begin
    FUnMarshal := TDBXClientCommand(FGetCustomerDataCommand.Parameters[0].ConnectionHandler).GetJSONUnMarshaler;
    try
      Result := TFDJSONDataSets(FUnMarshal.UnMarshal(FGetCustomerDataCommand.Parameters[0].Value.GetJSONValue(True)));
      if FInstanceOwner then
        FGetCustomerDataCommand.FreeOnExecute(Result);
    finally
      FreeAndNil(FUnMarshal)
    end
  end
  else
    Result := nil;
end;

function TServerMethods1Client.GetCustomerDataJSON: TJSONObject;
begin
  if FGetCustomerDataJSONCommand = nil then
  begin
    FGetCustomerDataJSONCommand := FDBXConnection.CreateCommand;
    FGetCustomerDataJSONCommand.CommandType := TDBXCommandTypes.DSServerMethod;
    FGetCustomerDataJSONCommand.Text := 'TServerMethods1.GetCustomerDataJSON';
    FGetCustomerDataJSONCommand.Prepare;
  end;
  FGetCustomerDataJSONCommand.ExecuteUpdate;
  Result := TJSONObject(FGetCustomerDataJSONCommand.Parameters[0].Value.GetJSONValue(FInstanceOwner));
end;

procedure TServerMethods1Client.ApplyCustomerUpdates(ADeltaList: TFDJSONDeltas);
begin
  if FApplyCustomerUpdatesCommand = nil then
  begin
    FApplyCustomerUpdatesCommand := FDBXConnection.CreateCommand;
    FApplyCustomerUpdatesCommand.CommandType := TDBXCommandTypes.DSServerMethod;
    FApplyCustomerUpdatesCommand.Text := 'TServerMethods1.ApplyCustomerUpdates';
    FApplyCustomerUpdatesCommand.Prepare;
  end;
  if not Assigned(ADeltaList) then
    FApplyCustomerUpdatesCommand.Parameters[0].Value.SetNull
  else
  begin
    FMarshal := TDBXClientCommand(FApplyCustomerUpdatesCommand.Parameters[0].ConnectionHandler).GetJSONMarshaler;
    try
      FApplyCustomerUpdatesCommand.Parameters[0].Value.SetJSONValue(FMarshal.Marshal(ADeltaList), True);
      if FInstanceOwner then
        ADeltaList.Free
    finally
      FreeAndNil(FMarshal)
    end
    end;
  FApplyCustomerUpdatesCommand.ExecuteUpdate;
end;

procedure TServerMethods1Client.ApplyCustomerUpdatesJSON(JSONObject: TJSONObject);
begin
  if FApplyCustomerUpdatesJSONCommand = nil then
  begin
    FApplyCustomerUpdatesJSONCommand := FDBXConnection.CreateCommand;
    FApplyCustomerUpdatesJSONCommand.CommandType := TDBXCommandTypes.DSServerMethod;
    FApplyCustomerUpdatesJSONCommand.Text := 'TServerMethods1.ApplyCustomerUpdatesJSON';
    FApplyCustomerUpdatesJSONCommand.Prepare;
  end;
  FApplyCustomerUpdatesJSONCommand.Parameters[0].Value.SetJSONValue(JSONObject, FInstanceOwner);
  FApplyCustomerUpdatesJSONCommand.ExecuteUpdate;
end;


constructor TServerMethods1Client.Create(ADBXConnection: TDBXConnection);
begin
  inherited Create(ADBXConnection);
end;


constructor TServerMethods1Client.Create(ADBXConnection: TDBXConnection; AInstanceOwner: Boolean);
begin
  inherited Create(ADBXConnection, AInstanceOwner);
end;


destructor TServerMethods1Client.Destroy;
begin
  FDataModuleCreateCommand.DisposeOf;
  FGetCustomerDataCommand.DisposeOf;
  FGetCustomerDataJSONCommand.DisposeOf;
  FApplyCustomerUpdatesCommand.DisposeOf;
  FApplyCustomerUpdatesJSONCommand.DisposeOf;
  inherited;
end;

end.

