unit MainFormu;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Param, FireDAC.Stan.Error, FireDAC.DatS, FireDAC.Phys.Intf,
  FireDAC.DApt.Intf, Vcl.ExtCtrls, Vcl.DBCtrls, Data.DB, Vcl.Grids, Vcl.DBGrids,
  Vcl.StdCtrls, FireDAC.Comp.DataSet, FireDAC.Comp.Client, Datasnap.DBClient,
  Vcl.ComCtrls, Datasnap.Provider, FireDAC.DApt, FireDAC.Stan.Async;

type
  TForm1 = class(TForm)
    ClientDataSet: TClientDataSet;
    FDMemTable: TFDMemTable;
    DataSource: TDataSource;
    DataSetProvider: TDataSetProvider;
    RPShowContentBtn: TButton;
    RPRadioGroup: TRadioGroup;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    FDTableAdapter1: TFDTableAdapter;
    Label1: TLabel;
    SalEdit: TEdit;
    FDCommand1: TFDCommand;
    CancelUpdatesBtn: TButton;
    ApplyUpdatesBtn: TButton;
    UseCachedUpdatesCB: TCheckBox;
    procedure RPRadioGroupClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RPShowContentBtnClick(Sender: TObject);
    procedure DataSourceDataChange(Sender: TObject; Field: TField);
    procedure ApplyUpdatesBtnClick(Sender: TObject);
    procedure CancelUpdatesBtnClick(Sender: TObject);
    procedure UseCachedUpdatesCBClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses DataModuleu, shellapi;


procedure TForm1.ApplyUpdatesBtnClick(Sender: TObject);
begin
  if DBGrid1.DataSource.DataSet is TClientDataSet then
  begin
    TClientDataSet(DBGrid1.DataSource.DataSet).ApplyUpdates(-1);
  end
  else
  begin
    TFDMemTable(DBGrid1.DataSource.DataSet).ApplyUpdates(-1);
    TFDMemTable(DBGrid1.DataSource.DataSet).CommitUpdates;
  end;
end;

procedure TForm1.CancelUpdatesBtnClick(Sender: TObject);
begin
  if DBGrid1.DataSource.DataSet is TClientDataSet then
    TClientDataSet(DBGrid1.DataSource.DataSet).CancelUpdates
  else
    TFDMemTable(DBGrid1.DataSource.DataSet).CancelUpdates;
end;

procedure TForm1.UseCachedUpdatesCBClick(Sender: TObject);
begin
  if FDMemTable.CachedUpdates and FDMemTable.UpdatesPending then
    raise Exception.Create('Cannot exit cached updates mode on an ' +
                           'FDMemTable when updates are pending');
  ClientDataSet.LogChanges := UseCachedUpdatesCB.Checked;
  FDMemTable.CachedUpdates := UseCachedUpdatesCB.Checked;
end;

procedure TForm1.DataSourceDataChange(Sender: TObject; Field: TField);
begin
  if DBGrid1.DataSource.DataSet is TClientDataSet then
    CancelUpdatesBtn.Enabled := TClientDataSet(DBGrid1.DataSource.DataSet).ChangeCount > 0
  else
    CancelUpdatesBtn.Enabled := TFDMemTable(DBGrid1.DataSource.DataSet).ChangeCount > 0;
  ApplyUpdatesBtn.Enabled := CancelUpdatesBtn.Enabled;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  RPRadioGroup.ItemIndex := 0;
end;

procedure TForm1.RPRadioGroupClick(Sender: TObject);
begin
  case RPRadioGroup.ItemIndex of
    0: DataSource.DataSet := ClientDataSet;
    1: DataSource.DataSet := FDMemTable;
  end;
end;

procedure TForm1.RPShowContentBtnClick(Sender: TObject);
begin
  ClientDataSet.Close;
  FDMemTable.Close;
  DataSetProvider.Options := DataSetProvider.Options + [poAllowCommandText];
  ClientDataSet.CommandText := 'SELECT * FROM Employee WHERE Salary > :val;';
  ClientDataSet.Params[0].AsFloat := StrToFloat(SalEdit.Text);
  ClientDataSet.Open;
  ClientDataSet.LogChanges := UseCachedUpdatesCB.Checked;

  FDCommand1.Connection := DataModule1.FDConnection1;
  FDTableAdapter1.SelectCommand := FDCommand1;
  FDMemTable.Adapter := FDTableAdapter1;
  FDMemTable.CommandText := 'SELECT * FROM Employee WHERE Salary > :val;';
  FDMemTable.ParamByName('val').AsFloat := StrToFloat(SalEdit.Text);
  FDMemTable.Open;
  FDMemTable.LogChanges := UseCachedUpdatesCB.Checked;

end;


end.
