unit MainFormu;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Param, FireDAC.Stan.Error, FireDAC.DatS, FireDAC.Phys.Intf,
  FireDAC.DApt.Intf, Vcl.ExtCtrls, Vcl.DBCtrls, Data.DB, Vcl.Grids, Vcl.DBGrids,
  Vcl.StdCtrls, FireDAC.Comp.DataSet, FireDAC.Comp.Client, Datasnap.DBClient,
  Vcl.ComCtrls, Datasnap.Provider, FireDAC.Stan.StorageJSON,
  FireDAC.Stan.StorageXML;

type
  TForm1 = class(TForm)
    RPClientDataSet: TClientDataSet;
    RPFDMemTable: TFDMemTable;
    RPDataSource: TDataSource;
    RPDataSetProvider: TDataSetProvider;
    FDStanStorageJSONLink1: TFDStanStorageJSONLink;
    FDStanStorageXMLLink1: TFDStanStorageXMLLink;
    RPListBox: TListBox;
    RPShowContentBtn: TButton;
    RPRadioGroup: TRadioGroup;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    procedure RPRadioGroupClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RPShowContentBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ConfigureRecordPersistence;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses DataModuleu, ViewFormu, shellapi;

var
  DataDir: string = '';

procedure TForm1.ConfigureRecordPersistence;
begin
  RPRadioGroup.ItemIndex := 0;
  RPListBox.ItemIndex := 0;
  RPClientDataSet.Open;
  DataModule1.FDQuery1.Open;
  RPFDMemTable.CloneCursor(DataModule1.FDQuery1);
  DataModule1.FDQuery1.Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DataDir := ExtractFilePath(ParamStr(0));
  ConfigureREcordPersistence;
end;

procedure TForm1.RPRadioGroupClick(Sender: TObject);
begin
  case RPRadioGroup.ItemIndex of
    0: RPDataSource.DataSet := RPClientDataSet;
    1: RPDataSource.DataSet := RPFDMemTable;
  end;
end;

procedure TForm1.RPShowContentBtnClick(Sender: TObject);
var
  FileName: string;
begin
  case RPRadioGroup.ItemIndex of
    0:
    begin
      case RPListBox.ItemIndex of
        0:
        begin
          FileName := 'CDSformat.cds';
          ShellExecute(Application.Handle, 'open',
                       PCHAR('notepad.exe'), PCHAR(DataDir + FileName), nil, SW_SHOW);
          exit;
        end;
        1:  FileName := 'CDSXMLformat.xml';
        2:
        begin
          ShowMessage('JSON format not supported in ClientDataSets');
          exit;
        end;
      end;
      RPClientDataSet.SaveToFile(DataDir + FileName);
    end;
    1:
    begin
      case RPListBox.ItemIndex of
        0:  FileName := 'FDSformat.fds';
        1:  FileName := 'FMDSXMLformat.xml';
        2:  FileName := 'FMDSJSONformat.json';
      end;
      RPFDMemTable.SaveToFile(DataDir + FileName);
    end;
  end;
  ViewForm := TViewForm.Create(Self);
  try
    ViewForm.Initialize(nil);
    ViewForm.ViewMemo.Lines.LoadFromFile(DataDir + FileName);
    ViewForm.ShowModal;
  finally
    ViewForm.Release;
  end;
end;

end.
